Page MenuHomeVyOS Platform

Increase default gc_thresh
Closed, ResolvedPublicFEATURE REQUEST

Description

By default sysctl params for gc_thresh is small if we use VyOS as BRAS or DHCP Server (L2).
Also it can take negative effect if we use VRRP and active arp entries more than 512.
Default params:

net.ipv4.neigh.default.gc_thresh1 = 128
net.ipv4.neigh.default.gc_thresh2 = 512
net.ipv4.neigh.default.gc_thresh3 = 1024

net.ipv6.neigh.default.gc_thresh1 = 128
net.ipv6.neigh.default.gc_thresh2 = 512
net.ipv6.neigh.default.gc_thresh3 = 1024

Proposed params:

net.ipv4.neigh.default.gc_thresh1 = 2048
net.ipv4.neigh.default.gc_thresh2 = 4096
net.ipv4.neigh.default.gc_thresh3 = 8192

net.ipv6.neigh.default.gc_thresh1 = 2048
net.ipv6.neigh.default.gc_thresh2 = 4096
net.ipv6.neigh.default.gc_thresh3 = 8192

Sure we can increase this params via CLI, but I think best practices if we add this params by default.

set system ip arp table-size 8192
set system ipv6 neighbor table-size 8192

Details

Difficulty level
Unknown (require assessment)
Version
-
Why the issue appeared?
Will be filled on close
Is it a breaking change?
Unspecified (possibly destroys the router)

Event Timeline

Dmitry created this task.Nov 26 2019, 10:35 PM
pasik added a subscriber: pasik.Nov 27 2019, 6:19 PM
syncer assigned this task to jestabro.Jan 1 2020, 1:59 PM
syncer triaged this task as High priority.
syncer edited projects, added VyOS 1.2 Crux (VyOS 1.2.5); removed VyOS 1.2 Crux.
jestabro added a comment.EditedJan 15 2020, 4:33 PM

The size of an ARP cache entry is 384 bytes (x86-64), so the change will add ~720k -- ~3 MiB, which seems reasonable. I will add the suggested settings to sysctl defaults.

jestabro added a comment.EditedJan 15 2020, 5:20 PM

For consistency with the relative sizes set by CLI in the conf_mode script (system-ip.py), the default params should be:

net.ipv4.neigh.default.gc_thresh1 = 1024
net.ipv4.neigh.default.gc_thresh2 = 4096
net.ipv4.neigh.default.gc_thresh3 = 8192

net.ipv6.neigh.default.gc_thresh1 = 1024
net.ipv6.neigh.default.gc_thresh2 = 4096
net.ipv6.neigh.default.gc_thresh3 = 8192
jestabro closed this task as Resolved.Jan 15 2020, 7:43 PM
jestabro moved this task from Need Triage to Finished on the VyOS 1.3 Equuleus board.
jestabro moved this task from Needs Triage to Backlog on the VyOS 1.2 Crux (VyOS 1.2.5) board.
c-po added a subscriber: c-po.EditedJan 16 2020, 8:27 AM

As I recently rewrote this part in XML/Python please also check the default values in the Python script

if this lines up with your expected behavior. This was rewritten und uses the same logic as in crux so the sysctl setting could probably be backported, too.

Yes, thanks, c-po; the revised settings (above) are consistent with defaults and behaviour for both crux and equuleus.